function [Wc Wcp Rc]=classical_whitening(y,K);
global  fs l Nm n

%% calculate autocovariance for tau=0
    Ryy_0=cov(y')
    %eigenvalue decomposition
    [V_R0 DR0]=eig(Ryy_0);
    %create whitening matrix:
    %sort eigenvalues:
    [DR0s,sd]=sort(diag(DR0),'descend');
%% calculate sigma if Nm<l, include Nm largest
      if Nm==l
          sigma_sq=0;
      else
          sigma_sq=mean(DR0s((Nm+1):l))^2;
      end
          V_R0s=zeros(l,Nm);
      for i=1:Nm
          V_R0s(:,i)=V_R0(:,sd(i));
      end
%% Create whitening matrix
      Wc=inv((diag(DR0s(1:Nm))-sigma_sq*eye(Nm))^(1/2))*V_R0s'
      %calculate z
      for i=1:n
          z(:,i)=Wc*y(:,i);
      end
          
%% pseudoinvers of whitening matrix
%SVD-> Singular value Decomposition X = U*S*V'.
[U_,S_,V_] = svd(Wc);
%obtain s+ by replacing nonzero diagonal entri with its reciprocal, and
%transposing the resulting matrices p denotes pseudo invers
[r c]=size(S_);
for i=1:r;
    for j=1:c;
    if S_(i,j)~=0     
        S_(i,j)=1/S_(i,j);
    end
    end
end
S_p=S_';
Wcp=V_*S_p*U_'; %Moore-Penrose pseudoinverse

%% calculate correlation matrix
      Rc=[]; %nxK matrix set of correlation matrices
       c=1; %count lag
        [Ryy_cov lags]=xcov(z',K,'unbiased');%,'unbiased'); %,'unbiased');%,'coeff');
        Ryy=Ryy_cov(K+2:2*K+1,:);
        L=lags([K+2:2*K+1]);
        nl=length(L); %in case dK~=1;
for ii=1:K
    Ryy_cell{c}=zeros(Nm,Nm);
    for i=1:Nm %make a matrix R(tau) (nxn dimension)
        s=1+(i-1)*Nm; 
        e=Nm*i;
        Ryy_cell{c}(i,:)=[Ryy(ii,s:e)];
    end
    %nxK matrix set:
    Rc=[Rc Ryy_cell{c}];
    c=c+1;
end


