%check accelerations:
clear all; close all; clc;

imp=0; %%choose if you want import of acceleration series or just preprocessing/investigation of series
%fs=100Hz is assumed in the following
sensorID{1}='E03B0';
sensorID{2}='E0462';

date='06102014'; time1='22:48:40'; time2='22:47:32'; %%NB: check file directory if time is 23-01;
windfile='23:01:01'
time=windfile;

% adjust acceleration time series from different sensor to receive the same
% start time
IDserie='_00';
seq_length=30; %intervall in minutes
seq_numb=seq_length*60*100;

%% Import/Load acceleration
diff_hour1=str2num(time1(1:2))-str2num(time2(1:2))
diff_min1=str2num(time1(4:5))-str2num(time2(4:5))
diff_sec1=str2num(time1(7:8))-str2num(time2(7:8))

st=diff_hour*60*60*100+diff_min*60*100+diff_sec*100 %100 samples each second
if st<=0;
startn(1)=st+1; stopn(1)=startn(1)+seq_numb-1
startn(2)=1; stopn(2)=startn(2)+seq_numb-1;
time=time2;
elseif st>0; 
    startn(2)=st+1; stopn(2)=startn(2)+seq_numb-1
startn(1)=1; stopn(1)=startn(1)+seq_numb-1;
time=time1;
end

if imp==1
direction=0;
%import data from sensor 1
data_r{1}{direction+1}=ImportAcc(sensorID{1},direction,date,time1)
direction=1;
data_r{1}{direction+1}=ImportAcc(sensorID{1},direction,date,time1)
direction=2;
data_r{1}{direction+1}=ImportAcc(sensorID{1},direction,date,time1)
%import data from sensor 2
direction=0;
data_r{2}{direction+1}=ImportAcc(sensorID{2},direction,date,time2)
direction=1;
data_r{2}{direction+1}=ImportAcc(sensorID{2},direction,date,time2)
direction=2;
data_r{2}{direction+1}=ImportAcc(sensorID{2},direction,date,time2)

%ADJUST FOR DIFFERENCE BETWEEN FILES and INTERPOLATION
for direction=1:3;
    data_int{1}{direction}=interp1(data_r{1}{direction}(:,1),data_r{1}{direction}(:,2),data_r{1}{direction}(1,1):data_r{1}{direction}(end,1))%,'spline')%,'spline')
    data{1}{direction}=[((startn(1)-1):(stopn(1)-1))' data_int{1}{direction}(startn(1):stopn(1))'];
    data_int{2}{direction}=interp1(data_r{2}{direction}(:,1),data_r{2}{direction}(:,2),data_r{2}{direction}(1,1):data_r{2}{direction}(end,1))%,'spline')
    data{2}{direction}=[((startn(2)-1):(stopn(2)-1))' data_int{2}{direction}(startn(2):stopn(2))'];
end
%% plot with interpolation
   figure
   i=0;
   for direction=1:3;
       for sens=1:2;
           i=i+1;
   subplot(3,2,i)
   
    plot(data_r{sens}{direction}(:,1),data_r{sens}{direction}(:,2),'-+')
    hold on
    plot(data{sens}{direction}(:,1),data{sens}{direction}(:,2),'ro')
       end
   end
time=strrep(time, ':', '.');
save(['data' IDserie  date '_' time '_' num2str(seq_length) 'min.mat'],'data')
%% save in 6xn dimensional matrix
framedata=[data{1}{1}(:,2)';data{1}{2}(:,2)';data{1}{3}(:,2)';data{2}{1}(:,2)';data{2}{2}(:,2)';data{2}{3}(:,2)'];%';data{1}{1:3}'];
save(['Dolmsund' IDserie '_' date '_' time '_' num2str(seq_length) 'min.mat'],'framedata')
else
%load time series if importing is turned off
time=strrep(time, ':', '.');
load(['data' IDserie date '_' time '_' num2str(seq_length) 'min.mat']);
end

%%% THIS CAN BE LEFT OUT IF ONLY IMPORT OF ACCELERATIONS ARE SEARCHED AFTER
date=[date '_' num2str(seq_length) 'min_'];
time=strrep(time, ':', '.');
%% Acceleration figure, no filter
figure
c=1;
d=['xyz']
for direction=1:3
for k=1:2;


    subplot(3,2,c)
plot(data{k}{direction}(1:end,2))
hold on
% if k==1
% plot(sensor_12(direction,:),'r');
% elseif k==2
%    plot(sensor_12(3+direction,:),'r');
% end
ylabel('[g]')
title(['ID: ' sensorID{k} ' dir: ' d(direction)])
step=60*100*5;
value=60*100*seq_length;
set(gca,'XTick',[0:step:value]); %This are going to be the only values affected.
set(gca,'XTickLabel',[0:5:seq_length]); %This is what it's going to appear in those places
xlabel('min')
c=c+1;
end
end
suptitle(['Acceleration, no filter' num2str(seq_length)] )
%% SIGNAL PROCESSING
%check frequency distribution with welch function
%for pwelch
n=length(data{1}{1}(:,2));
numberofsegments=5;
window=ceil(n/numberofsegments);
noverlap=window/2;
%define filter
fs=100;
f_cut_lowpass=4*2/fs;
f_cut_heighpass=0.2*2/fs;
norm_fcl=f_cut_lowpass;
[b3 a3] = butter(5, f_cut_lowpass, 'low'); %cutoff frequency 10
[b3_h a3_h] = butter(5, f_cut_heighpass, 'high'); %cutoff frequency 
%butterworth filter plot
[H F]= freqz(b3,a3,window,fs);
[H1 F1]= freqz(b3_h,a3_h,window,fs);
figure(100)
plot(F,abs(H))
ylabel('gain')
xlabel('[Hz]')
title('Butterworth, lowpass')
figure(101)
plot(F1,abs(H1))
ylabel('gain')
xlabel('[Hz]')
title('Butterworth, highpass')
data_nodetrend=data;
%% Apply filters, calculate PSD
c=1;
for direction=1:3
    for k=1:2;
%detrend
data{k}{direction}(:,2)=detrend(data{k}{direction}(:,2),'constant');
[PSD{k}{direction} f{k}{direction}] = pwelch(data{k}{direction}(:,2),window,noverlap,2*window,fs);
%add lowpass and highpassfilter
data_filter{k}{direction}=filtfilt(b3,a3,data{k}{direction}(:,2));
%data_filter{k}{direction}=filtfilt(b3_h,a3_h,data_filter{k}{direction}(:,1));
%filtered PSD
[PSD_filter{k}{direction} f_filter{k}{direction}] = pwelch(data_filter{k}{direction}(:,1),window,noverlap,2*window,fs);%,window)%,noverlap)
%% figure 2 PSD nofilter
figure(2)
subplot(3,2,c)
%f{k}{direction}=w{k}{direction}*window;
plot(f{k}{direction},(PSD{k}{direction}))
ylabel('PSD')
title(['ID: ' sensorID{k} ' dir: ' d(direction)])
xlabel('Hz')
yy=max(PSD{k}{direction});
axis([0 6 0 yy])
%% figure 4 PSD, applied filter
figure(4)
subplot(3,2,c)
%f_filter{k}{direction}=w_filter{k}{direction}*window;
plot(f_filter{k}{direction},PSD_filter{k}{direction})
ylabel('PSD')
xlabel('[Hz]')
title(['ID: ' sensorID{k} ' dir: ' d(direction)])
yyf=max(PSD_filter{k}{direction});
axis([0 6 0 yyf])
%axis([0 20 0 30])
%% Figure 5 acceleration data, histfit, filtered values
figure(5)
%figure
subplot(3,2,c)
%histfit(data_filter{k}{direction}(:,1));
histfit(data_filter{k}{direction}(:,1));
title(['ID: ' sensorID{k} ' dir: ' d(direction)])
%% Figure 6 acceleration data, filtered
figure(6)
subplot(3,2,c)
plot(data_filter{k}{direction}(:,1))
ylabel('[g]')
title(['ID: ' sensorID{k} ' dir: ' d(direction)])
step=60*100*5;
value=60*100*seq_length;
set(gca,'XTick',[0:step:value]); %This are going to be the only values affected.
set(gca,'XTickLabel',[0:5:seq_length]); %This is what it's going to appea
xlabel('min')
%%
c=c+1;
end
end
%% add titles
figure(2)
suptitle('Power Spectral densities, no filter, accelerations')
%figure(3)
figure(4)
suptitle('Power Spectral densities on filtered values')
figure(5)
suptitle('Normal distribution of filtered acceleration time series')
figure(6)
suptitle('Filtered acceleration')
%% Resampling
%Resampling (apply lowpass filter first!)
%resample 1/4 of the original sampling freq: hence, new=25 Hz

for direction=1:3
for k=1:2;
factor1=4;
factor2=25; %nyquis=newsamlingfrq/2; lowpass fc=5; new fs=100*3/25=16
newfs=fs*factor1/factor2;
data_filter_resampled{k}{direction}=resample(data_filter{k}{direction},factor1,factor2);
end
end
save(['data' IDserie date '_' time '_filter.mat'],'data_filter')
save(['data' IDserie date '_' time '_filter_resampled_' num2str(newfs) '.mat'],'data_filter_resampled')
%% Test plot for sensor/direction
a='y';
prompt='plot closer look y/n ';
qu=input(prompt,'s')

if strcmp(qu,'n')
error('no plots presented') 
end
while strcmp(a,'y');

k=input('sensor 1/2: ')
direction=input('direction 1/2/3 (x,y,z): ')
%k=1; direction=1;
figure(20)

%f{k}{direction}=w{k}{direction}*window;
plot(f{k}{direction},(PSD{k}{direction}))
ylabel('PSD')
title(['PSD, nofiltering, zeropadded, pwelch ID: ' sensorID{k} ' dir: ' d(direction)])
xlabel('Hz')
yy=max(PSD{k}{direction});
axis([0 6 0 yy])

figure(40)

plot(f_filter{k}{direction},PSD_filter{k}{direction})
ylabel('PSD')
title(['PSD, applied filter ID: ' sensorID{k} ' dir: ' d(direction)])
yyff=max(PSD_filter{k}{direction});
axis([0 6 0 yyff])
figure(60)
subplot(2,1,1)
plot(data{k}{direction}(1:1000,2))
title('no filter')
subplot(2,1,2)
plot(data_filter{k}{direction}(1:1000,1))
title('filter')
ylabel('[g]')
suptitle(['time series, 200 s, ID: ' sensorID{k} ' dir: ' d(direction)])

a=input('continue y/n ','s')
end
