%criteria for time series
%mean wind speed 7+-1 m/s
%direction 90 +-10 degrees, remember to choose appropiate 
clear all; close all; clc; 

date='27012015' %%NOTE: adjust folder in import_wind if the searched date is before 15.january
time_seq=30; %minutes
findmean=7;
numbmax=20;
dir_tol=15;

[data vec_date vec_time]=import_wind(date); %m=date ddmmyyyy

%data=record(startRow:end) wind_dir(startRow:end) wind_speed(startRow:end) wind_vel(startRow:end) date/time]
[m n]=size(data)
c=1;
%wind is sampled with 1 hz, thus, 8pm equal 3600*8 sample values
start_c=1;
end_c=start_c+time_seq*60-1;
i=1;
indices=[];
while end_c<=m
    startval(i)=start_c;
    endval(i)=end_c;
    windspeed(:,i)=data(start_c:end_c,3);
    [ro co]=size(windspeed);
    wind_dir(:,i)=data(start_c:end_c,2);
   wind_vel(:,i)=data(start_c:end_c,4);
    for j=1:ro
        if abs(windspeed(j,i))>=100; %remove spikes
        windspeed(j,i)=0;
        end
        
         if abs(wind_vel(j,i))>=100; %remove spikes
        wind_vel(j,i)=0;
         end
        
    end
    meanspeed(i)=mean(windspeed(:,i));
    mean_direction(i)=mean(wind_dir(:,i));
    
    tol_wind=abs(meanspeed(i)-findmean);
tol_dir1=abs(mean_direction(i)-90);
tol_dir2=abs(mean_direction(i)-270);
dir_crit=or(tol_dir1<=dir_tol,tol_dir2<=dir_tol)
if and(tol_wind<=1,dir_crit)
    indices(c)=i
    c=c+1;
end
start_c=start_c+(time_seq/2)*60;
end_c=start_c+time_seq*60-1;
i=i+1;
end


%hent ut dato og klokkeslett +record number
lid=length(indices)+1;
seq1=cell(lid,8)
seq1(1,:)={'datestart','dateend','timestart','timend','speedmean','direction','recordstart','recordend'};
for k=1:length(indices);
 ind=indices(k); 
  seq1(k+1,1)=vec_date(startval(ind));
seq1(k+1,2)=vec_date(endval(ind));

seq1(k+1,3)=vec_time(startval(ind));
seq1(k+1,4)=vec_time(endval(ind));
seq1(k+1,5)={meanspeed((ind))};
seq1(k+1,6)={mean_direction(ind)};

 seq1(k+1,7)={data(startval(ind),1)}; %start
seq1(k+1,8)={data(endval(ind),1)};  %end

seq.record(k,1)=data(startval(ind),1); %start
seq.record(k,2)=data(endval(ind),1);  %end
seq.date(k,1)=vec_date(startval(ind));
seq.date(k,2)=vec_date(endval(ind));
seq.time(k,1)=vec_time(startval(ind));
seq.time(k,2)=vec_time(endval(ind));
seq.speed(k,1)=meanspeed((ind));
seq.dir(k,1)=mean_direction(ind);
end

ind_meanspeed_unsort=[1:length(meanspeed); meanspeed]';
[meanspeedsort ind_sort]=sort(ind_meanspeed_unsort(:,2),'descend');

ind_meanspeed=[ind_sort meanspeedsort]
max=cell(numbmax,8);
max(1,:)={'datestart','dateend','timestart','timend','speedmean','direction','recordstart','recordend'};
for k=2:numbmax;
 ind=ind_sort(k-1); 
 max(k,1)=vec_date(startval(ind));
max(k,2)=vec_date(endval(ind));

max(k,3)=vec_time(startval(ind));
max(k,4)=vec_time(endval(ind));
max(k,5)={meanspeed((ind))};
max(k,6)={mean_direction(ind)};

 max(k,7)={data(startval(ind),1)}; %start
max(k,8)={data(endval(ind),1)};  %end


max1.record(k,1)=data(startval(ind),1); %start
max1.record(k,2)=data(endval(ind),1);  %end
max1.date(k,1)=vec_date(startval(ind));
max1.date(k,2)=vec_date(endval(ind));
max1.time(k,1)=vec_time(startval(ind));
max1.time(k,2)=vec_time(endval(ind));
max1.speed(k,1)=meanspeed((ind));
max1.dir(k,1)=mean_direction(ind);
end

filename = 'windfiles_imp.xlsx';
sheet = 1;
%xlRange = 'ABCDEF';
xlswrite(filename,max,1,'A');%,xlRange) %2:maxdata
xlswrite(filename,seq1,1,'M');%,xlRange) %2:maxdata

figure
plot(1:length(data),data(:,3))
title('wind speed, one day')
ylabel('m/s')
% Create a uicontrol of type "text"
mean_windspeed=mean(data(:,3))
mTextBox = uicontrol('style','text')
set(mTextBox,'String',['Mean wind' num2str(mean_windspeed)])
%Box itself
mTextBoxPosition = get(mTextBox,'Position') 
%set(mTextBox,'Units','characters')
set(mTextBox,'Position',[350 350 120 20])


%% PLOT
prompt='plot yes/no: ';
num=input(prompt,'s');
if strcmp(num,'no')
error('no plots presented') 
end
while strcmp(num,'yes');
prompt='choose time series to plot';
ind=input(prompt);

figure
plot(windspeed(:,ind))
title(['wind speed, serie ' num2str(ind)])
ylabel('m/s')
s=startval(ind);
e=endval(ind);
nn=length(s:e);

figure
plot(wind_dir(:,ind))
title('winddirection')
hold on
figure
histfit(windspeed(:,ind)')
figure
fs=1
n_w=length(windspeed(:,ind));
numberofsegments=1;
window=ceil(n_w/numberofsegments);
noverlap=window/2;

[PSD_w f_w] = pwelch(windspeed(:,ind)',window,noverlap,2*window,fs);%,window)%,noverlap)
plot(f_w,PSD_w)
[PSD_vel f_vel] = pwelch(wind_vel(:,ind)',window,noverlap,2*window,fs)
figure

wind_dir(:,ind)=unwrap(wind_dir(:,ind)*pi/180,(2*pi));
wind_dir(:,ind)=wind_dir(:,ind)*180/pi;

wdirl=length(wind_dir(:,ind))
direction=mean(wind_dir(:,ind))
polar((pi/180)*wind_dir(:,ind)',1:wdirl,'ob')
hold on
polar((pi/180)*direction*ones(1,wdirl),1:wdirl,'--r')
mTextBox = uicontrol('style','text')
set(mTextBox,'String',['Mean direction ' num2str(direction)])
set(mTextBox,'Position',[400 350 120 20])

figure
subplot(2,3,1)
plot(windspeed(:,ind))
axis([0 time_seq*60 -inf inf])
title(['U(t), windspeed, serie ' num2str(ind)])
ylabel('m/s')
xlabel('t [s]')
subplot(3,3,2)
histfit(windspeed(:,ind))

sigma(1)=std(windspeed(:,ind))
ylabel('number of bins')
xlabel('U(t)')
subplot(2,3,3)
plot(f_w,PSD_w)
xlabel('frequency [Hz]')
ylabel('Power spectrum')

subplot(2,3,4)
plot(wind_vel(:,ind))
axis([0 time_seq*60 -inf inf])
title(['w(t), windspeed vertical, serie ' num2str(ind)])
ylabel('m/s')
xlabel('t [s]')
subplot(2,3,5)
histfit(wind_vel(:,ind))
ylabel('number of bins')
xlabel('w(t)')
%histfit vertikal windspeed
sigma(2)=std(wind_vel(:,ind))
subplot(2,3,6)
plot(f_vel,PSD_vel)

figure
%subplot(1,3,1)
plot(wind_dir(:,ind))
hold on
plot(1:nn,direction*ones(1,nn),'r')
axis([0 time_seq*60 -inf inf])
title('\circ winddirection')
ylabel('[\circ]')
xlabel('t [s]')

figure
polar((pi/180)*wind_dir(1:nn,ind)',1:nn,'ob')
hold on
polar((pi/180)*direction*ones(1,nn),1:nn,'--r')
mTextBox = uicontrol('style','text')
set(mTextBox,'String',['Mean direction ' num2str(direction)])
set(mTextBox,'Position',[400 350 120 20])

end
